> For the complete documentation index, see [llms.txt](https://docs.enzyme.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.enzyme.finance/onyx-protocol/contract-implementations/fees.md).

# Fees

## FeeHandler

The core contract for registering, settling, and distributing fees.

See [Fees](/onyx-protocol/architecture/fees.md) for the configuration and mechanics.

## Management Fees

### ContinuousFlatRateManagementFeeTracker

Uses an annualized rate (e.g., 10%) to apply a time-based fee on net value.

Config:

* `rate` : annualized fee percentage

Setup:

1. Call `setRate(rate)`: sets `rate`
2. Call `resetLastSettled()`: initializes fee with current timestamp

Notes:

* `resetLastSettled()` can be called at any time to re-initialize fee with current timestamp (e.g., after updating the rate).

## Performance Fees

### ContinuousFlatRatePerformanceFeeTracker

Uses a flat rate (e.g., 10%) to apply a performance-based fee on net share value growth.

Config:

* `rate` : fee percentage applied to share value growth

Setup:

1. Call `setRate(rate)`: sets `rate`&#x20;
2. Call `resetHighWaterMark()`: initializes fee with current share price as the HWM

Fee Mechanics:

* If `currentNetShareValue > HWM`, then:
  * the fee is settled as: `fee = rate * valueIncreasePerShare * numberOfShares`&#x20;
  * HWM is updated
* Performance is *only* charged on value increase above the HWM

Notes:

* `resetHighWaterMark()` can be called at any time to re-initialize fee with the current share price as HWM (e.g., to have granular performance periods).
* Due to the fee mechanics, to the extent and duration that  `currentNetShareValue < HWM`, investors have a "free ride".


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.enzyme.finance/onyx-protocol/contract-implementations/fees.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
